import java.awt.*;
/**
 * A rectangular box that "knows" its own location, shape, color, and speed,
 * and can display itself on the screen.
 * 
 * @author Stephen Bloch
 * @version 12, Sept 13 2006
 */
public class Box
{
    // instance variables
    private Color color;
    private int x, y;
    private int width, height;
    private int dx, dy;

    /**
     * Constructor for objects of class Box
     * 
     * @param color  the Box's fill color
     * @param x      the initial x-coordinate of the top-left corner
     * @param y      the initial y-coordinate of the top-left corner
     * @param width  the box's width in pixels
     * @param height the box's height in pixels
     * @param dx     how many pixels right to move at each move() call
     * @param dy     how many pixels down to move at each move() call
     */
    public Box(Color color, int x, int y, int width, int height, int dx, int dy)
    {
        // initialise instance variables
        this.color = color;
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.dx = dx;
        this.dy = dy;
    }

    /**
     * Display the box on a given graphics context.
     * 
     * @param g2   a Graphics2D context into which to draw.
     */
    public void show (Graphics2D g2) {
        g2.setColor (this.color);
        g2.fill (new Rectangle (this.x, this.y, this.width, this.height));
        }
    
    /**
     * Move the box.
     */
    public void move () {
        this.x += this.dx;
        this.y += this.dy;
       }
}