import javax.swing.JComponent;
import java.awt.*;
import java.awt.geom.*;
/**
 * A simple graphics component, displaying a box that moves continuously.
 * 
 * Changes since version 11: the Box now "knows" its own color, size,
 * shape, and speed, as well as its own location.
 * The behavior should be exactly the same except that the box is blue,
 * but this approach is much more flexible (as we'll see in subsequent
 * versions).
 * 
 * @author Stephen Bloch
 * @version 12, Sept 13 2006
 */
public class MyComponent extends JComponent
{
    // instance variables
    /** @since version 11 */
    private Box theBox;
    /**
     * Constructor for objects of class MyComponent
     */
    public MyComponent()
    {
        // initialize instance variables
        this.theBox = new Box(Color.BLUE, 75, 58, 21, 34, 2, 3);
    }

    /**
     * Display a box.
     * 
     * @param  g    a Graphics context into which we are to draw
     */
    public void paintComponent (Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        
        this.theBox.show (g2);
        
        // update the location
        this.theBox.move ();
        
        // force another redisplay soon
        this.repaint (this.getVisibleRect());
    }
}
