import javax.swing.JComponent;
import java.awt.*;
import java.awt.geom.*;
/**
 * A simple graphics component, displaying a box that moves continuously.
 * 
 * Changes since version 12: there are now three different Boxes, of different
 * locations, shapes, sizes, colors, and speeds.
 * 
 * @author Stephen Bloch
 * @version 13, Sept 13 2006
 */
public class MyComponent extends JComponent
{
    // instance variables
    /** @since version 11 */
    private Box theBox;
    /** @since version 13 */
    private Box box2, box3;
    /**
     * Constructor for objects of class MyComponent
     */
    public MyComponent()
    {
        // initialize instance variables
        this.theBox = new Box(Color.BLUE, 75, 58, 21, 34, 2, 3);
        this.box2 = new Box(Color.ORANGE, 300, 10, 15, 9, -2, 1);
        this.box3 = new Box(Color.GREEN, 400, 600, 5, 20, -2, -3);
    }

    /**
     * Display a box.
     * 
     * @param  g    a Graphics context into which we are to draw
     */
    public void paintComponent (Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        
        this.theBox.show (g2);
        this.box2.show (g2);
        this.box3.show (g2);
        
        // update the locations
        this.theBox.move ();
        this.box2.move ();
        this.box3.move ();
        
        for (int wasteTime = 0; wasteTime < 10000000; ++wasteTime) {}
        
        // force another redisplay soon
        this.repaint (this.getVisibleRect());
    }
}
