import javax.swing.JComponent;
import java.awt.*;
import java.awt.geom.*;
/**
 * A simple graphics component, displaying some shapes and text.
 * Changes from version 7: added an ellipse, a line, and a string.
 * 
 * @author Stephen Bloch (partly copied from Horstmann's book)
 * @version 8, Sept 13 2006
 */
public class MyComponent extends JComponent
{
    /**
     * Constructor for objects of class MyComponent
     */
    public MyComponent()
    {
        // do nothing, for now.
    }

    /**
     * Display some shapes and text.
     * 
     * @param  g    a Graphics context into which we are to draw
     */
    public void paintComponent (Graphics g) {
        Graphics2D g2 = (Graphics2D)g;
        
        Rectangle box1 = new Rectangle (5, 10, 20, 30);
        g2.draw(box1);
        
        box1.translate (15, 5);
        g2.setColor (Color.BLUE);
        g2.draw(box1);
        
        Ellipse2D loop = new Ellipse2D.Double (30, 5, 55, 34);
        g2.setColor (Color.ORANGE);
        g2.draw(loop);
        
        Ellipse2D otherLoop = new Ellipse2D.Double (10, 25, 21, 34);
        g2.setColor (Color.GREEN);
        g2.fill(otherLoop);
        
        Line2D diagonal = new Line2D.Double (150, 0, 0, 150);
        g2.setColor (Color.RED);
        g2.draw(diagonal);
        
        g2.setColor (Color.MAGENTA);
        g2.drawString ("Isn't this exciting?", 20, 150);
    }
}
